
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class OrganizationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const organizations = await db.organizations.create(
            {
                id: data.id || undefined,
        
        name: data.name
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        

        

        

        return organizations;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const organizationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                name: item.name
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const organizations = await db.organizations.bulkCreate(organizationsData, { transaction });

        // For each item created, replace relation files
        

        return organizations;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const organizations = await db.organizations.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.name !== undefined) updatePayload.name = data.name;
        
        
        updatePayload.updatedById = currentUser.id;

        await organizations.update(updatePayload, {transaction});

        
        

        
        

        

        return organizations;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const organizations = await db.organizations.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        if (organizations.length !== ids.length) {
            const error = new Error('One or more items were not found in the current organization scope.');
            error.code = 404;
            throw error;
        }

        await db.sequelize.transaction(async (transaction) => {
            for (const record of organizations) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of organizations) {
                await record.destroy({transaction});
            }
        });


        return organizations;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const organizations = await db.organizations.findByPk(id, options);

        if (!organizations) {
            const error = new Error('Item not found in the current organization scope.');
            error.code = 404;
            throw error;
        }

        await organizations.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await organizations.destroy({
            transaction
        });

        return organizations;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const organizations = await db.organizations.findOne(
            { where },
            { transaction },
        );

        if (!organizations) {
            return organizations;
        }

        const output = organizations.get({plain: true});

        
        output.users_organizations = await organizations.getUsers_organizations({
            transaction
        });
        
        
        
        
        
        output.tenants_organizations = await organizations.getTenants_organizations({
            transaction
        });
        
        
        output.service_lines_organizations = await organizations.getService_lines_organizations({
            transaction
        });
        
        
        output.services_organizations = await organizations.getServices_organizations({
            transaction
        });
        
        
        output.companies_organizations = await organizations.getCompanies_organizations({
            transaction
        });
        
        
        output.contacts_organizations = await organizations.getContacts_organizations({
            transaction
        });
        
        
        output.tags_organizations = await organizations.getTags_organizations({
            transaction
        });
        
        
        output.pipelines_organizations = await organizations.getPipelines_organizations({
            transaction
        });
        
        
        output.deal_stages_organizations = await organizations.getDeal_stages_organizations({
            transaction
        });
        
        
        output.leads_organizations = await organizations.getLeads_organizations({
            transaction
        });
        
        
        output.deals_organizations = await organizations.getDeals_organizations({
            transaction
        });
        
        
        output.project_templates_organizations = await organizations.getProject_templates_organizations({
            transaction
        });
        
        
        output.projects_organizations = await organizations.getProjects_organizations({
            transaction
        });
        
        
        output.milestones_organizations = await organizations.getMilestones_organizations({
            transaction
        });
        
        
        output.tasks_organizations = await organizations.getTasks_organizations({
            transaction
        });
        
        
        output.task_dependencies_organizations = await organizations.getTask_dependencies_organizations({
            transaction
        });
        
        
        output.deliverables_organizations = await organizations.getDeliverables_organizations({
            transaction
        });
        
        
        output.project_risks_organizations = await organizations.getProject_risks_organizations({
            transaction
        });
        
        
        output.project_status_reports_organizations = await organizations.getProject_status_reports_organizations({
            transaction
        });
        
        
        output.skills_organizations = await organizations.getSkills_organizations({
            transaction
        });
        
        
        output.team_members_organizations = await organizations.getTeam_members_organizations({
            transaction
        });
        
        
        output.team_member_skills_organizations = await organizations.getTeam_member_skills_organizations({
            transaction
        });
        
        
        output.resource_allocations_organizations = await organizations.getResource_allocations_organizations({
            transaction
        });
        
        
        output.leave_requests_organizations = await organizations.getLeave_requests_organizations({
            transaction
        });
        
        
        output.public_holidays_organizations = await organizations.getPublic_holidays_organizations({
            transaction
        });
        
        
        output.timesheets_organizations = await organizations.getTimesheets_organizations({
            transaction
        });
        
        
        output.time_entries_organizations = await organizations.getTime_entries_organizations({
            transaction
        });
        
        
        output.products_organizations = await organizations.getProducts_organizations({
            transaction
        });
        
        
        output.contracts_organizations = await organizations.getContracts_organizations({
            transaction
        });
        
        
        output.invoices_organizations = await organizations.getInvoices_organizations({
            transaction
        });
        
        
        output.invoice_line_items_organizations = await organizations.getInvoice_line_items_organizations({
            transaction
        });
        
        
        output.payments_organizations = await organizations.getPayments_organizations({
            transaction
        });
        
        
        output.support_slas_organizations = await organizations.getSupport_slas_organizations({
            transaction
        });
        
        
        output.support_tickets_organizations = await organizations.getSupport_tickets_organizations({
            transaction
        });
        
        
        output.ticket_comments_organizations = await organizations.getTicket_comments_organizations({
            transaction
        });
        
        
        output.csat_surveys_organizations = await organizations.getCsat_surveys_organizations({
            transaction
        });
        
        
        output.email_templates_organizations = await organizations.getEmail_templates_organizations({
            transaction
        });
        
        
        output.notifications_organizations = await organizations.getNotifications_organizations({
            transaction
        });
        
        
        output.audit_logs_organizations = await organizations.getAudit_logs_organizations({
            transaction
        });
        
        
        output.imports_organizations = await organizations.getImports_organizations({
            transaction
        });
        
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.name) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'organizations',
                        'name',
                        filter.name,
                    ),
                };
            }
            

            
            

            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            




            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.organizations.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationsId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'organizations',
                        'name',
                        query,
                    ),
                ],
            };
        }

        const records = await db.organizations.findAll({
            attributes: [ 'id', 'name' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['name', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.name,
        }));
    }

    
};

